Subject: gdb crash examining "this" in C++
From: "Michael D. Crawford" <[email-masked]>
To: [email-masked]
Date: Mon, 29 Oct 2001 04:54:32 -0500

I have a repeatable crash in my program using gdb to debug a C++ program.  The 
crash happens when I view local variables, then click the "+" symbol to expand 
the view of "this".

When I select "Local Variables" from the View menu, the stack window pops up and 
shows the stack where my program is located.

There are two ways I have this happening.  One way is to let the program run 
until it hits an error in my code, so my program gets a segmentation violation.
In this case I get the following message about gdb:

The instruction at "0x6633c540" referenced memory at "0x65676471".  The memory 
could not be "read".

In the other case, I set a breakpoint before my crash, and trying to view this 
locks up gdb and I have to kill it with the task manager.

What's really weird is that it was working great with this program for the last 
week.  I had a bad bug - and infinite loop in my program, and couldn't get my 
program to terminate or gdb to quit, so I reset my computer.  Could I have 
damaged something gdb depended on?  It's been whacky since then.  I was running 
a slightly earlier gdb, but updated to the latest just now to make sure the bug 
still existed.

Mike
[email-masked]

gdb 5.0 (20010428-3)

g++ 2.95.3-5

cygcheck -s -v -r shows:

Cygnus Win95/NT Configuration Diagnostics
Current System Time: Mon Oct 29 04:49:31 2001

WinNT Ver 4.0 build 1381 Service Pack 6

Path: 
/usr/local/bin
	/usr/bin
	/bin
	/cygdrive/d/WINNT/system32
	/cygdrive/d/WINNT
	/cygdrive/d/Program Files/Network Associates/PGPNT
	/cygdrive/d/gnu/emacs-21.1/bin
	.
	/cygdrive/c/COREL/OFFICE7/SHARED/TRUEDOC/BIN

SysDir: D:\WINNT\System32
WinDir: D:\WINNT

PWD = `/cygdrive/e/MktResDev/Tests/CygWin'
LD_LIBRARY_PATH = `/cygdrive/c/COREL/OFFICE7/SHARED/TRUEDOC/BIN'
USER = `mike'
MAKE_MODE = `unix'
HOME = `/home/mike'

NUMBER_OF_PROCESSORS = `1'
PROMPT = `$P$G'
LOGONSERVER = `\\BJARNE'
OS2LIBPATH = `D:\WINNT\system32\os2\dll;'
COMSPEC = `D:\WINNT\system32\cmd.exe'
SYSTEMDRIVE = `D:'
HOSTNAME = `BJARNE'
PROCESSOR_REVISION = `0803'
!D: = `D:\cygwin\bin'
PATHEXT = `.COM;.EXE;.BAT;.CMD'
COMPUTERNAME = `BJARNE'
CLASSPATH = `.;c:\COREL\OFFICE7\SHARED\BARISTA;c:\COREL\OFFICE7\SHARED\TRUEDOC'
WINDIR = `D:\WINNT'
USERPROFILE = `D:\WINNT\Profiles\mike'
PS1 = `\[\033]0;\w\007
\033[32m\]\u@\h \[\033[33m\w\033[0m\]
$ '
MACHTYPE = `i686-pc-cygwin'
PROCESSOR_IDENTIFIER = `x86 Family 6 Model 8 Stepping 3, GenuineIntel'
OS = `Windows_NT'
OLDPWD = `/cygdrive/e'
PROCESSOR_ARCHITECTURE = `x86'
TEMP = `/cygdrive/d/TEMP'
PROCESSOR_LEVEL = `6'
SYSTEMROOT = `D:\WINNT'
HOMEDRIVE = `D:'
SHLVL = `1'
HOMEPATH = `\Mike'
USERDOMAIN = `BJARNE'
USERNAME = `mike'
SHELL = `/bin/bash'
HOSTTYPE = `i686'
OSTYPE = `cygwin'
TERM = `cygwin'
_ = `/usr/bin/cygcheck'
TZ = `EST5EDT4,M4.1.0/2,M10.5.0/2'

HKEY_CURRENT_USER\Software\Cygnus Solutions
HKEY_CURRENT_USER\Software\Cygnus Solutions\Cygwin
HKEY_CURRENT_USER\Software\Cygnus Solutions\Cygwin\mounts v2
   (default) = `/cygdrive'
   cygdrive flags = 0x00000022
HKEY_CURRENT_USER\Software\Cygnus Solutions\Cygwin\mounts v2\/enhydra3.0.1
   (default) = `\enhydra3.0.1'
   flags = 0x00000000
HKEY_CURRENT_USER\Software\Cygnus Solutions\Cygwin\mounts v2\/usr/local/enhydra
   (default) = `d:\usr\local\enhydra3.0.1'
   flags = 0x00000000
HKEY_CURRENT_USER\Software\Cygnus Solutions\Cygwin\mounts v2\/usr/local/enhydra3.0.1
   (default) = `D:\usr\local\enhydra3.0.1'
   flags = 0x00000002
HKEY_CURRENT_USER\Software\Cygnus Solutions\Cygwin\Program Options

a:  fd           N/A    N/A
c:  hd  FAT     2047Mb  99% CP    UN
d:  hd  NTFS    2047Mb  95% CP CS UN PA FC
e:  hd  NTFS    1004Mb  98% CP CS UN PA FC     Spot
f:  cd  CDFS       0Mb -2147483548%    CS              Audio CD

D:\usr\local\enhydra3.0.1  /usr/local/enhydra3.0.1  user    binmode
d:\usr\local\enhydra3.0.1  /usr/local/enhydra  user    textmode
D:\cygwin\bin  /usr/bin  system  binmode
D:\cygwin\lib  /usr/lib  system  binmode
\enhydra3.0.1  /enhydra3.0.1  user    textmode
D:\cygwin  /        system  binmode
c:    /cygdrive/c  user    binmode,noumount
d:    /cygdrive/d  user    binmode,noumount
e:    /cygdrive/e  user    binmode,noumount
f:    /cygdrive/f  user    binmode,noumount

Found: D:\cygwin\bin\bash.exe
Found: D:\cygwin\bin\cat.exe
Found: D:\cygwin\bin\cpp.exe
Found: D:\cygwin\bin\find.exe
Found: D:\cygwin\bin\gcc.exe
Found: D:\cygwin\bin\gdb.exe
Found: D:\cygwin\bin\ld.exe
Found: D:\cygwin\bin\ls.exe
Found: D:\cygwin\bin\make.exe
Found: D:\cygwin\bin\sh.exe

    56k 2000/12/03 D:\cygwin\bin\cygbz21.0.dll - os=4.0 img=1.0 sys=4.0
                   "cygbz21.0.dll" v0.0 ts=2000/11/20 18:53
    34k 2001/09/30 D:\cygwin\bin\cygform6.dll - os=4.0 img=1.0 sys=4.0
                   "cygform6.dll" v0.0 ts=2001/9/29 22:43
    18k 2000/10/23 D:\cygwin\bin\cyggdbm.dll - os=4.0 img=1.0 sys=4.0
                   "cyggdbm.dll" v0.0 ts=2000/10/22 22:26
    17k 2001/06/28 D:\cygwin\bin\cyghistory4.dll - os=4.0 img=1.0 sys=4.0
                   "cyghistory4.dll" v0.0 ts=2001/1/6 23:34
    21k 2001/06/28 D:\cygwin\bin\cyghistory5.dll - os=4.0 img=1.0 sys=4.0
                   "cyghistory5.dll" v0.0 ts=2001/6/27 22:27
    21k 2001/06/20 D:\cygwin\bin\cygintl.dll - os=4.0 img=1.0 sys=4.0
                   "cygintl.dll" v0.0 ts=2001/6/20 13:09
    81k 2001/10/20 D:\cygwin\bin\cygitcl30.dll - os=4.0 img=1.0 sys=4.0
                   "cygitcl30.dll" v0.0 ts=2001/10/19 20:25
    35k 2001/10/20 D:\cygwin\bin\cygitk30.dll - os=4.0 img=1.0 sys=4.0
                   "cygitk30.dll" v0.0 ts=2001/10/19 20:25
    45k 2001/07/04 D:\cygwin\bin\cygjbig1.dll - os=4.0 img=1.0 sys=4.0
                   "cygjbig1.dll" v0.0 ts=2001/7/3 23:25
   119k 2001/06/06 D:\cygwin\bin\cygjpeg6b.dll - os=4.0 img=1.0 sys=4.0
                   "cygjpeg6b.dll" v0.0 ts=2001/6/6 0:27
    19k 2001/09/30 D:\cygwin\bin\cygmenu6.dll - os=4.0 img=1.0 sys=4.0
                   "cygmenu6.dll" v0.0 ts=2001/9/29 22:43
   175k 2001/09/30 D:\cygwin\bin\cygncurses++6.dll - os=4.0 img=1.0 sys=4.0
                   "cygncurses++6.dll" v0.0 ts=2001/9/29 22:45
   201k 2001/09/30 D:\cygwin\bin\cygncurses6.dll - os=4.0 img=1.0 sys=4.0
                   "cygncurses6.dll" v0.0 ts=2001/9/29 22:42
    12k 2001/09/30 D:\cygwin\bin\cygpanel6.dll - os=4.0 img=1.0 sys=4.0
                   "cygpanel6.dll" v0.0 ts=2001/9/29 22:43
   163k 2001/05/06 D:\cygwin\bin\cygpng2.dll - os=4.0 img=1.0 sys=4.0
                   "cygpng2.dll" v0.0 ts=2001/5/6 0:05
   108k 2001/06/28 D:\cygwin\bin\cygreadline4.dll - os=4.0 img=1.0 sys=4.0
                   "cygreadline4.dll" v0.0 ts=2001/1/6 23:34
   135k 2001/06/28 D:\cygwin\bin\cygreadline5.dll - os=4.0 img=1.0 sys=4.0
                   "cygreadline5.dll" v0.0 ts=2001/6/27 22:27
   390k 2001/10/20 D:\cygwin\bin\cygtcl80.dll - os=4.0 img=1.0 sys=4.0
                   "cygtcl80.dll" v0.0 ts=2001/10/19 20:24
     5k 2001/10/20 D:\cygwin\bin\cygtclpip80.dll - os=4.0 img=1.0 sys=4.0
    10k 2001/10/20 D:\cygwin\bin\cygtclreg80.dll - os=4.0 img=1.0 sys=4.0
                   "cygtclreg80.dll" v0.0 ts=2001/10/19 20:24
   245k 2001/06/12 D:\cygwin\bin\cygtiff3.dll - os=4.0 img=1.0 sys=4.0
                   "cygtiff3.dll" v0.0 ts=2001/6/12 13:25
   623k 2001/10/20 D:\cygwin\bin\cygtk80.dll - os=4.0 img=1.0 sys=4.0
                   "cygtk80.dll" v0.0 ts=2001/10/19 20:25
    41k 2001/07/04 D:\cygwin\bin\cygXpm-noX4.dll - os=4.0 img=1.0 sys=4.0
                   "cygXpm-noX4.dll" v0.0 ts=2001/7/3 21:21
    45k 2001/07/04 D:\cygwin\bin\cygXpm-X4.dll - os=4.0 img=1.0 sys=4.0
                   "cygXpm-X4.dll" v0.0 ts=2000/11/19 21:45
    49k 2001/02/03 D:\cygwin\bin\cygz.dll - os=4.0 img=1.0 sys=4.0
                   "cygz.dll" v0.0 ts=2001/2/3 15:35
   701k 2001/09/13 D:\cygwin\bin\cygwin1.dll - os=4.0 img=1.0 sys=4.0
                   "cygwin1.dll" v0.0 ts=2001/9/12 23:54
     Cygwin DLL version info:
         dll major: 1003
         dll minor: 3
         dll epoch: 19
         dll bad signal mask: 19005
         dll old termios: 5
         dll malloc env: 28
         api major: 0
         api minor: 46
         shared data: 3
         dll identifier: cygwin1
         mount registry: 2
         cygnus registry name: Cygnus Solutions
         cygwin registry name: Cygwin
         program options name: Program Options
         cygwin mount registry name: mounts v2
         cygdrive flags: cygdrive flags
         cygdrive prefix: cygdrive prefix
         cygdrive default prefix:
         build date: Wed Sep 12 23:54:31 EDT 2001
         shared id: cygwin1S3

Use -h to see help about each section

-- 
Michael D. Crawford
GoingWare Inc. - Expert Software Development and Consulting
http://www.goingware.com
[email-masked]

   Tilting at Windmills for a Better Tomorrow.

     "I give you this one rule of conduct. Do what you will, but speak
      out always. Be shunned, be hated, be ridiculed, be scared,
      be in doubt, but don't be gagged."
      -- John J. Chapman, "Make a Bonfire of Your Reputations"
         http://www.goingware.com/reputation/

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Bug reporting:         http://cygwin.com/bugs.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/